-- updates for 6.2

-- User action changes


CREATE TABLE USER_ACTION(
UA_ID number(19) NOT NULL,
ACTION_WHEN timestamp NOT NULL,
OPERATION_TYPE varchar2(50) NOT NULL,
USERNAME nvarchar2(50) NOT NULL,
ENTITY_TYPE varchar2(50) NOT NULL,
ENTITY_ID number(19) NOT NULL,
ENTITY_NAME nvarchar2(255) NOT NULL,
PRIMARY KEY (UA_ID))
;

CREATE SEQUENCE USER_ACTION_UA_ID_SEQ
INCREMENT BY 1
START WITH 1
NOMAXVALUE
MINVALUE 1
NOCYCLE
NOCACHE
NOORDER
;

CREATE OR REPLACE TRIGGER SET_USER_ACTION_UA_ID
BEFORE INSERT
ON USER_ACTION
FOR EACH ROW
BEGIN
  SELECT USER_ACTION_UA_ID_SEQ.NEXTVAL
  INTO :NEW.UA_ID
  FROM DUAL;
END;
/

CREATE OR REPLACE PROCEDURE INSERT_USER_ACTION(
p_action_when IN timestamp,
p_operation_type IN varchar2,
p_username IN nvarchar2,
p_entity_type IN varchar2,
p_entity_id IN number,
p_entity_name IN nvarchar2,
p_pk OUT number)
AS
BEGIN
		INSERT INTO USER_ACTION (ACTION_WHEN,OPERATION_TYPE,USERNAME,ENTITY_TYPE,ENTITY_ID,ENTITY_NAME) VALUES (p_action_when, p_operation_type, p_username, p_entity_type, p_entity_id, p_entity_name) RETURNING UA_ID INTO p_pk;
END;
/


-- always last
update DB_VERSION SET VERSION = '6.2'
;

